"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.StaticText = exports.FormatStyle = exports.OutputFileStrategy = void 0;
const kinds_1 = require("../theme/constants/kinds");
/**
 * Defines outputFileStrategy model for the `outputFileStrategy` option.
 *
 * @enum
 *
 */
exports.OutputFileStrategy = {
    Members: 'members',
    Modules: 'modules',
};
/**
 *
 * @enum
 */
exports.FormatStyle = {
    List: 'list',
    Table: 'table',
};
exports.StaticText = {
    'header.title': '{projectName} {version}',
    'header.readme': 'Readme',
    'header.docs': 'API',
    'breadcrumbs.home': '{projectName}',
    'footer.generator': 'Generated using TypeDoc and typedoc-plugin-markdown.',
    'title.indexPage': '{projectName} {version}',
    'title.modulePage': '{name}',
    'title.memberPage': '{kind}: {name}',
    'title.member': '{name}',
    'label.defaultValue': 'Default value',
    'label.description': 'Description',
    'label.extendedBy': 'Extended by',
    'label.extends': 'Extends',
    'label.globals': 'Globals',
    'label.implements': 'Implements',
    'label.implementationOf': 'Implementation of',
    'label.inheritedFrom': 'Inherited from',
    'label.index': 'Index',
    'label.indexable': 'Indexable',
    'label.indexSignature': 'Index signature',
    'label.member': 'Member',
    'label.modifier': 'Modifier',
    'label.overrides': 'Overrides',
    'label.packages': 'Packages',
    'label.reExports': 'Re-exports',
    'label.renamesAndReExports': 'Renames and re-exports',
    'label.returns': 'Returns',
    'label.source': 'Source',
    'label.type': 'Type',
    'label.typeDeclaration': 'Type declaration',
    'label.value': 'Value',
    ...kinds_1.KIND_DEFAULTS,
};
/*export const MembersWithOwnFile = [
  ReflectionKind[ReflectionKind.Enum],
  ReflectionKind[ReflectionKind.Variable],
  ReflectionKind[ReflectionKind.Function],
  ReflectionKind[ReflectionKind.Class],
  ReflectionKind[ReflectionKind.Interface],
  ReflectionKind[ReflectionKind.TypeAlias],
];*/
