/**
 *
 * A set of helpers that parses TypeDoc models to be consumed by theme resources.
 *
 * @module
 */
import { DeclarationReflection, ParameterReflection, ProjectReflection, SignatureReflection } from 'typedoc';
export declare function getDeclarationType(declaration: DeclarationReflection): import("typedoc").SomeType | undefined;
export declare function getProjectDisplayName(project: ProjectReflection, includeVersion: boolean): string;
export declare function hasIndex(reflection: DeclarationReflection | ProjectReflection): boolean | undefined;
export declare function isAbsoluteIndex(reflection: DeclarationReflection | ProjectReflection): boolean | undefined;
export declare function isGroupKind(reflection: DeclarationReflection | SignatureReflection): boolean;
export declare function getModifier(reflection: DeclarationReflection): "private" | "public" | "readonly" | "protected" | "static" | "abstract" | "get" | "set" | null;
export declare const KEYWORD_MAP: {
    128: string;
    256: string;
    8: string;
    2097152: string;
    64: string;
};
export declare function getMemberTitle(reflection: DeclarationReflection): string;
export declare function flattenDeclarations(props: DeclarationReflection[], includeSignatures?: boolean): any[];
export declare function getSignatureParameters(parameters: ParameterReflection[], format?: boolean): string;
export declare function getIndexFileName(reflection: ProjectReflection | DeclarationReflection, isPackages?: boolean): "packages.md" | "modules.md" | "globals.md";
