import { DeclarationReflection, ProjectReflection, ReflectionCategory, ReflectionGroup, Renderer, TypeDocOptions } from 'typedoc';
import { OutputFileStrategy } from '../options/maps';
import { NavigationItem } from '../theme/models';
import { MarkdownTheme } from './theme';
export declare class NavigationContext {
    theme: MarkdownTheme;
    options: Partial<TypeDocOptions>;
    renderer: Renderer;
    navigation: NavigationItem[];
    constructor(theme: MarkdownTheme, options: Partial<TypeDocOptions>, renderer: Renderer);
    getNavigation(project: ProjectReflection): NavigationItem[];
    buildNavigationFromPackage(projectChild: DeclarationReflection): void;
    buildNavigationFromProject(project: ProjectReflection | DeclarationReflection): void;
    getCategoryGroupChildren(group: ReflectionCategory): any;
    getGroupChildren(group: ReflectionGroup, outputFileStrategy?: OutputFileStrategy): any;
    getChildrenOrGroups(reflection: DeclarationReflection, outputFileStrategy?: OutputFileStrategy): any;
}
