"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.breadcrumbs = void 0;
const path = __importStar(require("path"));
const elements_1 = require("../../../support/elements");
const utils_1 = require("../../../support/utils");
const helpers_1 = require("../../helpers");
/**
 * Renders the breadcrumbs
 * @mergeTarget
 */
function breadcrumbs(context, page) {
    var _a, _b;
    const md = [];
    const entryFileName = context.options.getValue('entryFileName');
    if (page.url === page.project.url ||
        (page.url === entryFileName && page.url.split(path.sep).length === 1)) {
        return '';
    }
    const homeLabel = context
        .getTextContent('breadcrumbs.home')
        .replace('{projectName}', (0, helpers_1.getProjectDisplayName)(page.project, false));
    md.push((0, elements_1.link)(homeLabel, context.relativeURL(entryFileName)));
    const breadcrumb = (model) => {
        var _a;
        if ((_a = model === null || model === void 0 ? void 0 : model.parent) === null || _a === void 0 ? void 0 : _a.parent) {
            breadcrumb(model.parent);
        }
        const getUrl = (model) => {
            if (Boolean(model.readme)) {
                return `${path.dirname(model.url)}/${entryFileName}`;
            }
            return model.url;
        };
        md.push((0, elements_1.link)((0, utils_1.escapeChars)(model.name), context.relativeURL(getUrl(model))));
    };
    const pageName = (0, utils_1.escapeChars)(page.model.name);
    if (((_b = (_a = page.model) === null || _a === void 0 ? void 0 : _a.parent) === null || _b === void 0 ? void 0 : _b.parent) &&
        (page.url !== page.project.url ||
            page.url !== context.options.getValue('entryFileName'))) {
        breadcrumb(page.model.parent);
    }
    md.push(pageName);
    return md.length > 1 ? `${md.join(' / ')}` : '';
}
exports.breadcrumbs = breadcrumbs;
