"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.typeParametersList = void 0;
const elements_1 = require("../../../support/elements");
/**
 * @category Partials
 */
function typeParametersList(context, typeParameters, headingLevel) {
    const rows = [];
    typeParameters === null || typeParameters === void 0 ? void 0 : typeParameters.forEach((typeParameter) => {
        const row = [];
        const nameCol = [(0, elements_1.bold)(typeParameter.name)];
        if (typeParameter.type) {
            nameCol.push(`extends ${context.someType(typeParameter.type)}`);
        }
        if (typeParameter.default) {
            nameCol.push(`= ${context.someType(typeParameter.default)}`);
        }
        row.push('• ' + nameCol.join(' '));
        if (typeParameter.comment) {
            row.push(context.comment(typeParameter.comment));
        }
        rows.push(row.join('\n\n'));
    });
    return rows.join('\n\n');
}
exports.typeParametersList = typeParametersList;
