"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.accessorMember = void 0;
const typedoc_1 = require("typedoc");
const elements_1 = require("../../../support/elements");
/**
 * @category Partials
 */
function accessorMember(context, declaration, headingLevel) {
    var _a, _b, _c, _d, _e, _f;
    const md = [];
    if (declaration.getSignature) {
        md.push(context.signatureMemberIdentifier(declaration.getSignature, {
            accessor: 'get',
        }));
        if (declaration.getSignature.comment) {
            md.push(context.comment(declaration.getSignature.comment, headingLevel));
        }
    }
    if (declaration.setSignature) {
        md.push(context.signatureMemberIdentifier(declaration.setSignature, {
            accessor: 'set',
        }));
        if (declaration.setSignature.comment) {
            md.push(context.comment(declaration.setSignature.comment, headingLevel));
        }
    }
    if ((_b = (_a = declaration.setSignature) === null || _a === void 0 ? void 0 : _a.parameters) === null || _b === void 0 ? void 0 : _b.length) {
        md.push((0, elements_1.heading)(headingLevel, context.getTextContent('kind.parameter.plural')));
        if (context.options.getValue('parametersFormat') === 'table') {
            md.push(context.parametersTable(declaration.setSignature.parameters));
        }
        else {
            md.push(context.parametersList(declaration.setSignature.parameters));
        }
    }
    if ((_c = declaration.getSignature) === null || _c === void 0 ? void 0 : _c.type) {
        md.push(context.signatureMemberReturns(declaration.getSignature, headingLevel));
    }
    const showSources = !((_d = declaration === null || declaration === void 0 ? void 0 : declaration.parent) === null || _d === void 0 ? void 0 : _d.kindOf(typedoc_1.ReflectionKind.TypeLiteral));
    if (showSources && !context.options.getValue('disableSources')) {
        if ((_e = declaration.getSignature) === null || _e === void 0 ? void 0 : _e.sources) {
            md.push(context.sources(declaration.getSignature, headingLevel));
        }
        else if ((_f = declaration.setSignature) === null || _f === void 0 ? void 0 : _f.sources) {
            md.push(context.sources(declaration.setSignature, headingLevel));
        }
    }
    return md.join('\n\n');
}
exports.accessorMember = accessorMember;
