"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.constructorMember = void 0;
const elements_1 = require("../../../support/elements");
const utils_1 = require("../../../support/utils");
/**
 * @category Partials
 */
function constructorMember(context, reflection, headingLevel) {
    var _a;
    const md = [];
    (_a = reflection.signatures) === null || _a === void 0 ? void 0 : _a.forEach((signature) => {
        var _a;
        const params = (_a = signature.parameters) === null || _a === void 0 ? void 0 : _a.map((param) => param.name).join(', ');
        md.push((0, elements_1.heading)(headingLevel, `${(0, utils_1.escapeChars)(signature.name)}(${params})`));
        md.push(context.signatureMember(signature, headingLevel + 1));
    });
    return md.join('\n\n');
}
exports.constructorMember = constructorMember;
