"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.signatureMemberReturns = void 0;
const typedoc_1 = require("typedoc");
const elements_1 = require("../../../support/elements");
/**
 * @category Partials
 */
function signatureMemberReturns(context, signature, headingLevel) {
    var _a, _b, _c;
    const md = [];
    const typeDeclaration = (_a = signature.type) === null || _a === void 0 ? void 0 : _a.declaration;
    md.push((0, elements_1.heading)(headingLevel, context.getTextContent('label.returns')));
    md.push(getReturnType(context, typeDeclaration, signature.type));
    if ((_b = signature.comment) === null || _b === void 0 ? void 0 : _b.blockTags.length) {
        const tags = signature.comment.blockTags
            .filter((tag) => tag.tag === '@returns')
            .map((tag) => context.commentParts(tag.content));
        md.push(tags.join('\n\n'));
    }
    if (signature.type instanceof typedoc_1.ReferenceType &&
        ((_c = signature.type.typeArguments) === null || _c === void 0 ? void 0 : _c.length)) {
        if (signature.type.typeArguments[0] instanceof typedoc_1.ReflectionType) {
            md.push((0, elements_1.blockQuoteBlock)(context.typeDeclarationMember(signature.type.typeArguments[0].declaration, headingLevel)));
        }
    }
    if (typeDeclaration === null || typeDeclaration === void 0 ? void 0 : typeDeclaration.signatures) {
        typeDeclaration.signatures.forEach((signature) => {
            md.push((0, elements_1.blockQuoteBlock)(context.signatureMember(signature, headingLevel + 1, true)));
        });
    }
    if (typeDeclaration === null || typeDeclaration === void 0 ? void 0 : typeDeclaration.children) {
        md.push((0, elements_1.blockQuoteBlock)(context.typeDeclarationMember(typeDeclaration, headingLevel)));
    }
    return md.join('\n\n');
}
exports.signatureMemberReturns = signatureMemberReturns;
function getReturnType(context, typeDeclaration, type) {
    if (typeDeclaration === null || typeDeclaration === void 0 ? void 0 : typeDeclaration.children) {
        return (0, elements_1.backTicks)('Object');
    }
    if (typeDeclaration === null || typeDeclaration === void 0 ? void 0 : typeDeclaration.signatures) {
        return (0, elements_1.backTicks)('Function');
    }
    return type ? context.someType(type, true).replace(/\n/g, ' ') : '';
}
