"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.typeDeclarationMember = void 0;
const helpers_1 = require("../../helpers");
/**
 * @category Partials
 */
function typeDeclarationMember(context, typeDeclaration, headingLevel) {
    const md = [];
    if (typeDeclaration.children) {
        if (context.options.getValue('typeDeclarationFormat') === 'table') {
            md.push(context.typeDeclarationTable(typeDeclaration.children));
        }
        else {
            const declarations = (0, helpers_1.flattenDeclarations)(typeDeclaration.children);
            declarations.forEach((declaration) => {
                md.push(context.member(declaration, headingLevel + 1, true));
            });
        }
    }
    return md.join('\n\n');
}
exports.typeDeclarationMember = typeDeclarationMember;
