"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.pageTitle = void 0;
const typedoc_1 = require("typedoc");
const helpers_1 = require("../../helpers");
/**
 * @category Partials
 */
function pageTitle(context, page) {
    var _a;
    if (((_a = page.model) === null || _a === void 0 ? void 0 : _a.url) === page.project.url) {
        const titleContent = context.options.isSet('indexPageTitle')
            ? context.options.getValue('indexPageTitle')
            : context.getTextContent('title.indexPage');
        return context.indexTitle(titleContent, page.project.name, page.project.packageVersion);
    }
    const name = (0, helpers_1.getMemberTitle)(page.model);
    const textContent = page.model.kindOf(typedoc_1.ReflectionKind.Module)
        ? context.getTextContent('title.modulePage')
        : context.options.isSet('memberPageTitle')
            ? context.options.getValue('memberPageTitle')
            : context.getTextContent('title.memberPage');
    return textContent
        .replace('{name}', name)
        .replace('{kind}', context.kindString(page.model.kind));
}
exports.pageTitle = pageTitle;
