"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.typeDeclarationTable = void 0;
const elements_1 = require("../../../support/elements");
const utils_1 = require("../../../support/utils");
const helpers_1 = require("../../helpers");
/**
 * @category Partials
 */
function typeDeclarationTable(context, props) {
    const headers = [];
    headers.push(context.getTextContent('label.member'));
    headers.push(context.getTextContent('label.type'));
    headers.push(context.getTextContent('label.description'));
    const declarations = (0, helpers_1.flattenDeclarations)(props, true);
    const rows = [];
    declarations.forEach((declaration, index) => {
        const row = [];
        row.push((0, utils_1.formatTableNameCol)(declaration.name));
        row.push(context.someType(declaration.type).replace(/\n/g, ' '));
        const comments = declaration.comment;
        if (comments) {
            row.push((0, utils_1.stripLineBreaks)((0, utils_1.formatTableDescriptionCol)(context.comment(comments))));
        }
        else {
            row.push('-');
        }
        rows.push(row);
    });
    return (0, elements_1.table)(headers, rows);
}
exports.typeDeclarationTable = typeDeclarationTable;
