import { DeclarationReflection, Options, ProjectReflection, Renderer } from 'typedoc';
import { UrlMapping } from '../plugin/url-mapping';
import { UrlOption } from './models';
import { MarkdownTheme } from './theme';
export declare class UrlsContext {
    theme: MarkdownTheme;
    project: ProjectReflection;
    renderer: Renderer;
    options: Options;
    urls: UrlMapping[];
    anchors: Record<string, string[]>;
    constructor(theme: MarkdownTheme, project: ProjectReflection, renderer: Renderer, options: Options);
    /**
     * Map the models of the given project to the desired output files.
     * Based on TypeDoc DefaultTheme.getUrls()
     *
     * @param project  The project whose urls should be generated.
     */
    getUrls(): UrlMapping[];
    private buildUrlsFromPackage;
    /**
     *
     * @param project
     * @param isPackage
     */
    private buildUrlsFromProject;
    private buildUrlsFromGroup;
    getUrl(reflection: DeclarationReflection, urlPath: string): string;
    getUrlPath(reflection: DeclarationReflection, options: UrlOption): string;
    private applyAnchorUrl;
    private getAnchorId;
    private getAnchorName;
    private childrenIncludeNamespaces;
}
